package sample;
import javax.swing.SwingUtilities;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Rectangle;
import javax.swing.JLabel;
import java.awt.Component;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import java.awt.event.*;
import java.awt.Color;

public class MainFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JLabel jLabel = null;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				MainFrame thisClass = new MainFrame();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public MainFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("Sample");
		
		// ENbN
		initializeRightClickMenu(this);
		initializeRightClickMenu(jLabel);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(15, 15, 166, 31));
			jLabel.setText("ǂŉENbNI");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
		}
		return jContentPane;
	}
	
	/**
	 * ENbNj[s܂B
	 * 
	 * @param component ENbNsR|[lg
	 */
	private void initializeRightClickMenu(Component component) {
		// ENbNp̃j[`
		JMenuItem jmenuitem1, jmenuitem2, jmenuitem3, jmenuitem4, jmenuitem5;
		jmenuitem1 = new JMenuItem("Red");			// Pڂ̃j[
		jmenuitem2 = new JMenuItem("Blue");			// Qڂ̃j[
		jmenuitem3 = new JMenuItem("Yellow");		// Rڂ̃j[
		jmenuitem4 = new JMenuItem("Green");		// Sڂ̃j[
		jmenuitem5 = new JMenuItem("Default");		// Tڂ̃j[
		
		// ej[Ȉ
		jmenuitem1.addActionListener(new SampleActionListener("Red"));
		jmenuitem2.addActionListener(new SampleActionListener("Blue"));
		jmenuitem3.addActionListener(new SampleActionListener("Yellow"));
		jmenuitem4.addActionListener(new SampleActionListener("Green"));
		jmenuitem5.addActionListener(new SampleActionListener("Default"));
		
		// ENbNɕ\|bvAbv`
		JPopupMenu jpopup = new JPopupMenu();
		jpopup.add(jmenuitem1);				// Red
		jpopup.add(jmenuitem2);				// Blue
		jpopup.add(jmenuitem3);				// Yellow
		jpopup.add(jmenuitem4);				// Green
		jpopup.addSeparator();				// --------ij
		jpopup.add(jmenuitem5);				// Default
		
		// }EXCxgpXi[ǉ
		component.addMouseListener(new SampleMouseListener(
				component, jpopup));
		// |bvAbvt[ɐݒ
		this.add(jpopup);
	}
	
	/**
	 * }EXCxgXi[
	 */
	private class SampleMouseListener extends MouseAdapter {
		
		/**
		 * Cxg̃R|[lg
		 */
		private Component component;

		/**
		 * \|bvAbv
		 */
		JPopupMenu jpopup;

		/**
		 * RXgN^
		 * 
		 * @param component Cxg̃R|[lg
		 * @param jpopup \|bvAbv
		 */
		public SampleMouseListener(Component component, JPopupMenu jpopup) {
			super();
			this.component = component;
			this.jpopup = jpopup;
		}
		
		/**
		 * R|[lgŃ}EX{^ƌĂяo܂B
		 */
		public void mousePressed(MouseEvent e){
			
			/** Ê **/
			if(SwingUtilities.isRightMouseButton(e)) {
				
				// NbNꂽʒuɃ|bvAbv\
				jpopup.show(component, e.getX(), e.getY());
			}
		}
	}
	
	/**
	 * j[Ȉ
	 */
	private class SampleActionListener implements ActionListener {

		/**
		 * F\
		 */
		private String color;
		
		/**
		 * RXgN^
		 * 
		 * @param color F\
		 */
		public SampleActionListener(String color) {
			super();
			this.color = color;
		}
		
		/**
		 * Cxg̏
		 */
		public void actionPerformed(ActionEvent e) {
			
			if(color.equals("Red")) {
				getJContentPane().setBackground(Color.RED);
			}
			else if(color.equals("Blue")) {
				getJContentPane().setBackground(Color.BLUE);
			}
			else if(color.equals("Yellow")) {
				getJContentPane().setBackground(Color.YELLOW);
			}
			else if(color.equals("Green")) {
				getJContentPane().setBackground(Color.GREEN);
			}
			else if(color.equals("Default")) {
				getJContentPane().setBackground(null);
			}
		}
	}
}
